package gecco.communication.messages;

import java.io.DataOutput;
import java.io.IOException;
import java.io.DataInput;


/**
 * UnitPropertyDeleted.java
 *
 *
 * Created: Mon Sep 15 16:56:16 2003
 *
 * @author <a href="mailto:Hans.Sandstrom@fhs.mil.se">Hans Sandstrm</a>
 * @version
 */

public class UnitPropertyDeletedMessage extends Message {

    public int handle;
    public String key;
    public String newValue = null;

    public UnitPropertyDeletedMessage (int handle, String key){
	this.handle = handle;
	this.key = key;
    }
    
    public void write(DataOutput out) throws IOException{
	out.writeInt(MessageType.UnitPropertyDeleted);
	out.writeInt(handle);
	out.writeUTF(key);
    }

    public static Message read(DataInput in) throws IOException{
	int handle = in.readInt();
	String key = in.readUTF();
	return new UnitPropertyDeletedMessage(handle, key);
    }

}
