package gecco.game.dke;

import gecco.server.core.*;


/**
 * IndirectFireUnitAction.java
 *
 *
 * Created: Mon Nov 18 00:12:59 2002
 *
 * @author <a href="mailto:hans.sandstrom@fhs.mil.se">Hans Sandstrm</a>
 * @version
 */

public class IndirectFireUnitAction extends IndirectFireAction {

    Unit unitToTrack = null;
    int handleOfUnitToTrack = -1;

    public IndirectFireUnitAction (){
	super();
    }

    // Override superclass methods
    public void initiate(int _actionHandle, int _unitHandle) {
	throw new IllegalArgumentException("This action must be instanciated with a unit as an argument.");
    }

    public void initiate(int _actionHandle, int _unitHandle, int _argUnitHandle) {
	handleOfUnitToTrack = _argUnitHandle;
	unitToTrack = ReferenceHolder.getUnitManager().getUnit(_argUnitHandle);
	super.initiate(_actionHandle, _unitHandle, unitToTrack.getX(), unitToTrack.getY());
	// We are tracking a unit, no dispersion
	dispersion = 1;
	indirectFireFactor = ((WarUnit)getUnit()).getIndirectFireFactor();
    }
    
    public void initiate(int _actionHandle, int _unitHandle, double _argX, double _argY) {
	throw new IllegalArgumentException("This action must be instanciated with a unit as an argument.");
    }

    public ActionReturn checkPoint(){
	if (ReferenceHolder.getUnitManager().getUnit(handleOfUnitToTrack) == null){
	    return new ActionReturnCompleted("Unit no longer exists.");
	}
	if (ReferenceHolder.getUnitManager().getUnit(handleOfUnitToTrack).isDestroyed()) {
	    return new ActionReturnCompleted(Def.getTargetDestroyedMessage());
	}
	
	centerX = unitToTrack.getIntX();
	centerY = unitToTrack.getIntY();

	return super.checkPoint();
    }
    
}// IndirectFireUnitAction
