package gecco.game.dke;

import java.lang.Thread;
import gecco.server.core.ReferenceHolder;
import java.lang.InterruptedException;



/**
 * RefereeTimerThread.java
 *
 *
 * Created: Mon Sep 29 12:33:43 2003
 *
 * @author <a href=mailto:hans.sandstrom@fhs.mil.se> Hans Sandstrm </a>
 * @version 1.0
 */
public class RefereeTimerThread extends Thread {

    DKEReferee referee;
    double  returnValue;
    double wakeUpTime;

    /**
     * double returnValue = the value that should be passed to the referees timeIsUp(double) function.
     * double wakeUpTime = game time in seconds when the thread sould wake up.
     **/
    public RefereeTimerThread(DKEReferee referee, double returnValue, double wakeUpTime) {
	super();
	this.referee = referee;
	this.returnValue = returnValue;
	this.wakeUpTime = wakeUpTime;
	this.start();
    }
    
    public void run(){
	try {
	    ReferenceHolder.getClock().gameSleep(wakeUpTime - ReferenceHolder.getClock().gameTimeNow());
	} catch (InterruptedException e) {
	    // if intrrupted quit
	    return;
	}
	// Call the referee
	referee.timeIsUp(returnValue);
    }
    
}
