package gecco.game.dke;

import gecco.server.core.Action;
import gecco.server.core.ActionReturn;
import gecco.server.core.ActionReturnRequeue;
import gecco.server.core.ActionReturnCompleted;




/**
 * RegainStrengthAction.java
 *
 *
 * Created: Fri Sep 12 13:50:41 2003
 *
 * @author <a href=mailto:hans.sandstrom@fhs.mil.se> Hans Sandstrm </a>
 * @version 1.0
 */
public class RegainStrengthAction extends Action {

    int regainStrengthTime;
    StringBuffer sb = new StringBuffer(Def.getInitialRegainStrengthString());
    int nrOfSteps = Def.getNrOfRegainStrengthSteps();
    int remainingSteps = nrOfSteps;
    boolean firstRun = true;

    public RegainStrengthAction() {
	super();
    }


    /**
     *
     * @param param1 <description>
     * @param param2 <description>
     */
    public void initiate(int param1, int param2){
	super.initiate(param1, param2);
	regainStrengthTime = ((WarUnit)getUnit()).getRegainStrengthTime(); 
	((WarUnit) getUnit()).setRegainingStrength(true);
    }
    
    public ActionReturn checkPoint(){
	if (((WarUnit) getUnit()).isUnderAttack()||((WarUnit) getUnit()).isAttacking()) {
	    ((WarUnit) getUnit()).setRegainingStrength(false);
	    ((WarUnit) getUnit()).setRegainStrengthProperty("");
	    return new ActionReturnCompleted(Def.getRegainStrengthAbortedString());
	}
	if (firstRun) {
	    firstRun = false;
	    ((WarUnit) getUnit()).setRegainStrengthProperty(new String(sb));
	    return new ActionReturnRequeue(regainStrengthTime/nrOfSteps);
	}
	else {
	    remainingSteps--;
	    sb.deleteCharAt(0);
	    if (remainingSteps <= 0) {
		((WarUnit) getUnit()).setRegainingStrength(false);
		((WarUnit) getUnit()).regainStrength();
		((WarUnit) getUnit()).setRegainStrengthProperty("");
		return new ActionReturnCompleted();
	    }
	    ((WarUnit) getUnit()).setRegainStrengthProperty(new String(sb));
	    return new ActionReturnRequeue(regainStrengthTime/nrOfSteps);
	}
    }

    public void prepareAbortion(){
	((WarUnit) getUnit()).setRegainingStrength(false);
	((WarUnit) getUnit()).setRegainStrengthProperty("");
    }

}
